package starmap

import "sync"

var globalMap StarMapKV

type StarMapKV struct {
	kvMap    map[string]interface{}
	kvmu     sync.RWMutex
	kvMapPro map[string]StarMap
	kvmuPro  sync.RWMutex
}

type StarStack struct {
	kvPushmu sync.RWMutex
	kvStack  []interface{}
}

func init() {
	globalMap = NewStarMap()
}

func NewStarMap() StarMapKV {
	var mp StarMapKV
	mp.kvMap = make(map[string]interface{})
	mp.kvMapPro = make(map[string]StarMap)
	return mp
}
